import { Injectable, Directive, ElementRef, Input, ViewContainerRef, Renderer2, RendererFactory2, Component, ViewEncapsulation, ViewChild, Injector, ComponentFactoryResolver, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}

class JoyrideStep {
}

var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var root = createCommonjsModule(function (module, exports) {
/**
 * window: browser in DOM main thread
 * self: browser in WebWorker
 * global: Node.js/other
 */
exports.root = (typeof window == 'object' && window.window === window && window
    || typeof self == 'object' && self.self === self && self
    || typeof commonjsGlobal == 'object' && commonjsGlobal.global === commonjsGlobal && commonjsGlobal);
if (!exports.root) {
    throw new Error('RxJS could not find any global context (window, self, global)');
}

});
var root_1 = root.root;

function isFunction(x) {
    return typeof x === 'function';
}
var isFunction_2 = isFunction;


var isFunction_1 = {
	isFunction: isFunction_2
};

var isArray_1 = Array.isArray || (function (x) { return x && typeof x.length === 'number'; });


var isArray = {
	isArray: isArray_1
};

function isObject(x) {
    return x != null && typeof x === 'object';
}
var isObject_2 = isObject;


var isObject_1 = {
	isObject: isObject_2
};

// typeof any so that it we don't have to cast when comparing a result to the error object
var errorObject_1 = { e: {} };


var errorObject = {
	errorObject: errorObject_1
};

var tryCatchTarget;
function tryCatcher() {
    try {
        return tryCatchTarget.apply(this, arguments);
    }
    catch (e) {
        errorObject.errorObject.e = e;
        return errorObject.errorObject;
    }
}
function tryCatch(fn) {
    tryCatchTarget = fn;
    return tryCatcher;
}
var tryCatch_2 = tryCatch;


var tryCatch_1 = {
	tryCatch: tryCatch_2
};

var __extends$1 = (commonjsGlobal && commonjsGlobal.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
/**
 * An error thrown when one or more errors have occurred during the
 * `unsubscribe` of a {@link Subscription}.
 */
var UnsubscriptionError = (function (_super) {
    __extends$1(UnsubscriptionError, _super);
    function UnsubscriptionError(errors) {
        _super.call(this);
        this.errors = errors;
        var err = Error.call(this, errors ?
            errors.length + " errors occurred during unsubscription:\n  " + errors.map(function (err, i) { return ((i + 1) + ") " + err.toString()); }).join('\n  ') : '');
        this.name = err.name = 'UnsubscriptionError';
        this.stack = err.stack;
        this.message = err.message;
    }
    return UnsubscriptionError;
}(Error));
var UnsubscriptionError_2 = UnsubscriptionError;


var UnsubscriptionError_1 = {
	UnsubscriptionError: UnsubscriptionError_2
};

/**
 * Represents a disposable resource, such as the execution of an Observable. A
 * Subscription has one important method, `unsubscribe`, that takes no argument
 * and just disposes the resource held by the subscription.
 *
 * Additionally, subscriptions may be grouped together through the `add()`
 * method, which will attach a child Subscription to the current Subscription.
 * When a Subscription is unsubscribed, all its children (and its grandchildren)
 * will be unsubscribed as well.
 *
 * @class Subscription
 */
var Subscription = (function () {
    /**
     * @param {function(): void} [unsubscribe] A function describing how to
     * perform the disposal of resources when the `unsubscribe` method is called.
     */
    function Subscription(unsubscribe) {
        /**
         * A flag to indicate whether this Subscription has already been unsubscribed.
         * @type {boolean}
         */
        this.closed = false;
        if (unsubscribe) {
            this._unsubscribe = unsubscribe;
        }
    }
    /**
     * Disposes the resources held by the subscription. May, for instance, cancel
     * an ongoing Observable execution or cancel any other type of work that
     * started when the Subscription was created.
     * @return {void}
     */
    Subscription.prototype.unsubscribe = function () {
        var hasErrors = false;
        var errors;
        if (this.closed) {
            return;
        }
        this.closed = true;
        var _a = this, _unsubscribe = _a._unsubscribe, _subscriptions = _a._subscriptions;
        this._subscriptions = null;
        if (isFunction_1.isFunction(_unsubscribe)) {
            var trial = tryCatch_1.tryCatch(_unsubscribe).call(this);
            if (trial === errorObject.errorObject) {
                hasErrors = true;
                (errors = errors || []).push(errorObject.errorObject.e);
            }
        }
        if (isArray.isArray(_subscriptions)) {
            var index = -1;
            var len = _subscriptions.length;
            while (++index < len) {
                var sub = _subscriptions[index];
                if (isObject_1.isObject(sub)) {
                    var trial = tryCatch_1.tryCatch(sub.unsubscribe).call(sub);
                    if (trial === errorObject.errorObject) {
                        hasErrors = true;
                        errors = errors || [];
                        var err = errorObject.errorObject.e;
                        if (err instanceof UnsubscriptionError_1.UnsubscriptionError) {
                            errors = errors.concat(err.errors);
                        }
                        else {
                            errors.push(err);
                        }
                    }
                }
            }
        }
        if (hasErrors) {
            throw new UnsubscriptionError_1.UnsubscriptionError(errors);
        }
    };
    /**
     * Adds a tear down to be called during the unsubscribe() of this
     * Subscription.
     *
     * If the tear down being added is a subscription that is already
     * unsubscribed, is the same reference `add` is being called on, or is
     * `Subscription.EMPTY`, it will not be added.
     *
     * If this subscription is already in an `closed` state, the passed
     * tear down logic will be executed immediately.
     *
     * @param {TeardownLogic} teardown The additional logic to execute on
     * teardown.
     * @return {Subscription} Returns the Subscription used or created to be
     * added to the inner subscriptions list. This Subscription can be used with
     * `remove()` to remove the passed teardown logic from the inner subscriptions
     * list.
     */
    Subscription.prototype.add = function (teardown) {
        if (!teardown || (teardown === Subscription.EMPTY)) {
            return Subscription.EMPTY;
        }
        if (teardown === this) {
            return this;
        }
        var sub = teardown;
        switch (typeof teardown) {
            case 'function':
                sub = new Subscription(teardown);
            case 'object':
                if (sub.closed || typeof sub.unsubscribe !== 'function') {
                    break;
                }
                else if (this.closed) {
                    sub.unsubscribe();
                }
                else {
                    (this._subscriptions || (this._subscriptions = [])).push(sub);
                }
                break;
            default:
                throw new Error('unrecognized teardown ' + teardown + ' added to Subscription.');
        }
        return sub;
    };
    /**
     * Removes a Subscription from the internal list of subscriptions that will
     * unsubscribe during the unsubscribe process of this Subscription.
     * @param {Subscription} subscription The subscription to remove.
     * @return {void}
     */
    Subscription.prototype.remove = function (subscription) {
        // HACK: This might be redundant because of the logic in `add()`
        if (subscription == null || (subscription === this) || (subscription === Subscription.EMPTY)) {
            return;
        }
        var subscriptions = this._subscriptions;
        if (subscriptions) {
            var subscriptionIndex = subscriptions.indexOf(subscription);
            if (subscriptionIndex !== -1) {
                subscriptions.splice(subscriptionIndex, 1);
            }
        }
    };
    Subscription.EMPTY = (function (empty) {
        empty.closed = true;
        return empty;
    }(new Subscription()));
    return Subscription;
}());
var Subscription_2 = Subscription;


var Subscription_1 = {
	Subscription: Subscription_2
};

var empty = {
    closed: true,
    next: function (value) { },
    error: function (err) { throw err; },
    complete: function () { }
};


var Observer = {
	empty: empty
};

var Symbol = root.root.Symbol;
var $$rxSubscriber = (typeof Symbol === 'function' && typeof Symbol.for === 'function') ?
    Symbol.for('rxSubscriber') : '@@rxSubscriber';


var rxSubscriber = {
	$$rxSubscriber: $$rxSubscriber
};

var __extends$2 = (commonjsGlobal && commonjsGlobal.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};




/**
 * Implements the {@link Observer} interface and extends the
 * {@link Subscription} class. While the {@link Observer} is the public API for
 * consuming the values of an {@link Observable}, all Observers get converted to
 * a Subscriber, in order to provide Subscription-like capabilities such as
 * `unsubscribe`. Subscriber is a common type in RxJS, and crucial for
 * implementing operators, but it is rarely used as a public API.
 *
 * @class Subscriber<T>
 */
var Subscriber = (function (_super) {
    __extends$2(Subscriber, _super);
    /**
     * @param {Observer|function(value: T): void} [destinationOrNext] A partially
     * defined Observer or a `next` callback function.
     * @param {function(e: ?any): void} [error] The `error` callback of an
     * Observer.
     * @param {function(): void} [complete] The `complete` callback of an
     * Observer.
     */
    function Subscriber(destinationOrNext, error, complete) {
        _super.call(this);
        this.syncErrorValue = null;
        this.syncErrorThrown = false;
        this.syncErrorThrowable = false;
        this.isStopped = false;
        switch (arguments.length) {
            case 0:
                this.destination = Observer.empty;
                break;
            case 1:
                if (!destinationOrNext) {
                    this.destination = Observer.empty;
                    break;
                }
                if (typeof destinationOrNext === 'object') {
                    if (destinationOrNext instanceof Subscriber) {
                        this.destination = destinationOrNext;
                        this.destination.add(this);
                    }
                    else {
                        this.syncErrorThrowable = true;
                        this.destination = new SafeSubscriber(this, destinationOrNext);
                    }
                    break;
                }
            default:
                this.syncErrorThrowable = true;
                this.destination = new SafeSubscriber(this, destinationOrNext, error, complete);
                break;
        }
    }
    Subscriber.prototype[rxSubscriber.$$rxSubscriber] = function () { return this; };
    /**
     * A static factory for a Subscriber, given a (potentially partial) definition
     * of an Observer.
     * @param {function(x: ?T): void} [next] The `next` callback of an Observer.
     * @param {function(e: ?any): void} [error] The `error` callback of an
     * Observer.
     * @param {function(): void} [complete] The `complete` callback of an
     * Observer.
     * @return {Subscriber<T>} A Subscriber wrapping the (partially defined)
     * Observer represented by the given arguments.
     */
    Subscriber.create = function (next, error, complete) {
        var subscriber = new Subscriber(next, error, complete);
        subscriber.syncErrorThrowable = false;
        return subscriber;
    };
    /**
     * The {@link Observer} callback to receive notifications of type `next` from
     * the Observable, with a value. The Observable may call this method 0 or more
     * times.
     * @param {T} [value] The `next` value.
     * @return {void}
     */
    Subscriber.prototype.next = function (value) {
        if (!this.isStopped) {
            this._next(value);
        }
    };
    /**
     * The {@link Observer} callback to receive notifications of type `error` from
     * the Observable, with an attached {@link Error}. Notifies the Observer that
     * the Observable has experienced an error condition.
     * @param {any} [err] The `error` exception.
     * @return {void}
     */
    Subscriber.prototype.error = function (err) {
        if (!this.isStopped) {
            this.isStopped = true;
            this._error(err);
        }
    };
    /**
     * The {@link Observer} callback to receive a valueless notification of type
     * `complete` from the Observable. Notifies the Observer that the Observable
     * has finished sending push-based notifications.
     * @return {void}
     */
    Subscriber.prototype.complete = function () {
        if (!this.isStopped) {
            this.isStopped = true;
            this._complete();
        }
    };
    Subscriber.prototype.unsubscribe = function () {
        if (this.closed) {
            return;
        }
        this.isStopped = true;
        _super.prototype.unsubscribe.call(this);
    };
    Subscriber.prototype._next = function (value) {
        this.destination.next(value);
    };
    Subscriber.prototype._error = function (err) {
        this.destination.error(err);
        this.unsubscribe();
    };
    Subscriber.prototype._complete = function () {
        this.destination.complete();
        this.unsubscribe();
    };
    return Subscriber;
}(Subscription_1.Subscription));
var Subscriber_2 = Subscriber;
/**
 * We need this JSDoc comment for affecting ESDoc.
 * @ignore
 * @extends {Ignored}
 */
var SafeSubscriber = (function (_super) {
    __extends$2(SafeSubscriber, _super);
    function SafeSubscriber(_parent, observerOrNext, error, complete) {
        _super.call(this);
        this._parent = _parent;
        var next;
        var context = this;
        if (isFunction_1.isFunction(observerOrNext)) {
            next = observerOrNext;
        }
        else if (observerOrNext) {
            context = observerOrNext;
            next = observerOrNext.next;
            error = observerOrNext.error;
            complete = observerOrNext.complete;
            if (isFunction_1.isFunction(context.unsubscribe)) {
                this.add(context.unsubscribe.bind(context));
            }
            context.unsubscribe = this.unsubscribe.bind(this);
        }
        this._context = context;
        this._next = next;
        this._error = error;
        this._complete = complete;
    }
    SafeSubscriber.prototype.next = function (value) {
        if (!this.isStopped && this._next) {
            var _parent = this._parent;
            if (!_parent.syncErrorThrowable) {
                this.__tryOrUnsub(this._next, value);
            }
            else if (this.__tryOrSetError(_parent, this._next, value)) {
                this.unsubscribe();
            }
        }
    };
    SafeSubscriber.prototype.error = function (err) {
        if (!this.isStopped) {
            var _parent = this._parent;
            if (this._error) {
                if (!_parent.syncErrorThrowable) {
                    this.__tryOrUnsub(this._error, err);
                    this.unsubscribe();
                }
                else {
                    this.__tryOrSetError(_parent, this._error, err);
                    this.unsubscribe();
                }
            }
            else if (!_parent.syncErrorThrowable) {
                this.unsubscribe();
                throw err;
            }
            else {
                _parent.syncErrorValue = err;
                _parent.syncErrorThrown = true;
                this.unsubscribe();
            }
        }
    };
    SafeSubscriber.prototype.complete = function () {
        if (!this.isStopped) {
            var _parent = this._parent;
            if (this._complete) {
                if (!_parent.syncErrorThrowable) {
                    this.__tryOrUnsub(this._complete);
                    this.unsubscribe();
                }
                else {
                    this.__tryOrSetError(_parent, this._complete);
                    this.unsubscribe();
                }
            }
            else {
                this.unsubscribe();
            }
        }
    };
    SafeSubscriber.prototype.__tryOrUnsub = function (fn, value) {
        try {
            fn.call(this._context, value);
        }
        catch (err) {
            this.unsubscribe();
            throw err;
        }
    };
    SafeSubscriber.prototype.__tryOrSetError = function (parent, fn, value) {
        try {
            fn.call(this._context, value);
        }
        catch (err) {
            parent.syncErrorValue = err;
            parent.syncErrorThrown = true;
            return true;
        }
        return false;
    };
    SafeSubscriber.prototype._unsubscribe = function () {
        var _parent = this._parent;
        this._context = null;
        this._parent = null;
        _parent.unsubscribe();
    };
    return SafeSubscriber;
}(Subscriber));


var Subscriber_1 = {
	Subscriber: Subscriber_2
};

function toSubscriber(nextOrObserver, error, complete) {
    if (nextOrObserver) {
        if (nextOrObserver instanceof Subscriber_1.Subscriber) {
            return nextOrObserver;
        }
        if (nextOrObserver[rxSubscriber.$$rxSubscriber]) {
            return nextOrObserver[rxSubscriber.$$rxSubscriber]();
        }
    }
    if (!nextOrObserver && !error && !complete) {
        return new Subscriber_1.Subscriber(Observer.empty);
    }
    return new Subscriber_1.Subscriber(nextOrObserver, error, complete);
}
var toSubscriber_2 = toSubscriber;


var toSubscriber_1 = {
	toSubscriber: toSubscriber_2
};

function getSymbolObservable(context) {
    var $$observable;
    var Symbol = context.Symbol;
    if (typeof Symbol === 'function') {
        if (Symbol.observable) {
            $$observable = Symbol.observable;
        }
        else {
            $$observable = Symbol('observable');
            Symbol.observable = $$observable;
        }
    }
    else {
        $$observable = '@@observable';
    }
    return $$observable;
}
var getSymbolObservable_1 = getSymbolObservable;
var $$observable = getSymbolObservable(root.root);


var observable = {
	getSymbolObservable: getSymbolObservable_1,
	$$observable: $$observable
};

/**
 * A representation of any set of values over any amount of time. This the most basic building block
 * of RxJS.
 *
 * @class Observable<T>
 */
var Observable = (function () {
    /**
     * @constructor
     * @param {Function} subscribe the function that is  called when the Observable is
     * initially subscribed to. This function is given a Subscriber, to which new values
     * can be `next`ed, or an `error` method can be called to raise an error, or
     * `complete` can be called to notify of a successful completion.
     */
    function Observable(subscribe) {
        this._isScalar = false;
        if (subscribe) {
            this._subscribe = subscribe;
        }
    }
    /**
     * Creates a new Observable, with this Observable as the source, and the passed
     * operator defined as the new observable's operator.
     * @method lift
     * @param {Operator} operator the operator defining the operation to take on the observable
     * @return {Observable} a new observable with the Operator applied
     */
    Observable.prototype.lift = function (operator) {
        var observable$$1 = new Observable();
        observable$$1.source = this;
        observable$$1.operator = operator;
        return observable$$1;
    };
    Observable.prototype.subscribe = function (observerOrNext, error, complete) {
        var operator = this.operator;
        var sink = toSubscriber_1.toSubscriber(observerOrNext, error, complete);
        if (operator) {
            operator.call(sink, this.source);
        }
        else {
            sink.add(this._subscribe(sink));
        }
        if (sink.syncErrorThrowable) {
            sink.syncErrorThrowable = false;
            if (sink.syncErrorThrown) {
                throw sink.syncErrorValue;
            }
        }
        return sink;
    };
    /**
     * @method forEach
     * @param {Function} next a handler for each value emitted by the observable
     * @param {PromiseConstructor} [PromiseCtor] a constructor function used to instantiate the Promise
     * @return {Promise} a promise that either resolves on observable completion or
     *  rejects with the handled error
     */
    Observable.prototype.forEach = function (next, PromiseCtor) {
        var _this = this;
        if (!PromiseCtor) {
            if (root.root.Rx && root.root.Rx.config && root.root.Rx.config.Promise) {
                PromiseCtor = root.root.Rx.config.Promise;
            }
            else if (root.root.Promise) {
                PromiseCtor = root.root.Promise;
            }
        }
        if (!PromiseCtor) {
            throw new Error('no Promise impl found');
        }
        return new PromiseCtor(function (resolve, reject) {
            var subscription = _this.subscribe(function (value) {
                if (subscription) {
                    // if there is a subscription, then we can surmise
                    // the next handling is asynchronous. Any errors thrown
                    // need to be rejected explicitly and unsubscribe must be
                    // called manually
                    try {
                        next(value);
                    }
                    catch (err) {
                        reject(err);
                        subscription.unsubscribe();
                    }
                }
                else {
                    // if there is NO subscription, then we're getting a nexted
                    // value synchronously during subscription. We can just call it.
                    // If it errors, Observable's `subscribe` will ensure the
                    // unsubscription logic is called, then synchronously rethrow the error.
                    // After that, Promise will trap the error and send it
                    // down the rejection path.
                    next(value);
                }
            }, reject, resolve);
        });
    };
    Observable.prototype._subscribe = function (subscriber) {
        return this.source.subscribe(subscriber);
    };
    /**
     * An interop point defined by the es7-observable spec https://github.com/zenparsing/es-observable
     * @method Symbol.observable
     * @return {Observable} this instance of the observable
     */
    Observable.prototype[observable.$$observable] = function () {
        return this;
    };
    // HACK: Since TypeScript inherits static properties too, we have to
    // fight against TypeScript here so Subject can have a different static create signature
    /**
     * Creates a new cold Observable by calling the Observable constructor
     * @static true
     * @owner Observable
     * @method create
     * @param {Function} subscribe? the subscriber function to be passed to the Observable constructor
     * @return {Observable} a new cold observable
     */
    Observable.create = function (subscribe) {
        return new Observable(subscribe);
    };
    return Observable;
}());
var Observable_2 = Observable;


var Observable_1 = {
	Observable: Observable_2
};

var __extends$3 = (commonjsGlobal && commonjsGlobal.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
/**
 * An error thrown when an action is invalid because the object has been
 * unsubscribed.
 *
 * @see {@link Subject}
 * @see {@link BehaviorSubject}
 *
 * @class ObjectUnsubscribedError
 */
var ObjectUnsubscribedError = (function (_super) {
    __extends$3(ObjectUnsubscribedError, _super);
    function ObjectUnsubscribedError() {
        var err = _super.call(this, 'object unsubscribed');
        this.name = err.name = 'ObjectUnsubscribedError';
        this.stack = err.stack;
        this.message = err.message;
    }
    return ObjectUnsubscribedError;
}(Error));
var ObjectUnsubscribedError_2 = ObjectUnsubscribedError;


var ObjectUnsubscribedError_1 = {
	ObjectUnsubscribedError: ObjectUnsubscribedError_2
};

var __extends$4 = (commonjsGlobal && commonjsGlobal.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};

/**
 * We need this JSDoc comment for affecting ESDoc.
 * @ignore
 * @extends {Ignored}
 */
var SubjectSubscription = (function (_super) {
    __extends$4(SubjectSubscription, _super);
    function SubjectSubscription(subject, subscriber) {
        _super.call(this);
        this.subject = subject;
        this.subscriber = subscriber;
        this.closed = false;
    }
    SubjectSubscription.prototype.unsubscribe = function () {
        if (this.closed) {
            return;
        }
        this.closed = true;
        var subject = this.subject;
        var observers = subject.observers;
        this.subject = null;
        if (!observers || observers.length === 0 || subject.isStopped || subject.closed) {
            return;
        }
        var subscriberIndex = observers.indexOf(this.subscriber);
        if (subscriberIndex !== -1) {
            observers.splice(subscriberIndex, 1);
        }
    };
    return SubjectSubscription;
}(Subscription_1.Subscription));
var SubjectSubscription_2 = SubjectSubscription;


var SubjectSubscription_1 = {
	SubjectSubscription: SubjectSubscription_2
};

var __extends$5 = (commonjsGlobal && commonjsGlobal.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};






/**
 * @class SubjectSubscriber<T>
 */
var SubjectSubscriber = (function (_super) {
    __extends$5(SubjectSubscriber, _super);
    function SubjectSubscriber(destination) {
        _super.call(this, destination);
        this.destination = destination;
    }
    return SubjectSubscriber;
}(Subscriber_1.Subscriber));
/**
 * @class Subject<T>
 */
var Subject = (function (_super) {
    __extends$5(Subject, _super);
    function Subject() {
        _super.call(this);
        this.observers = [];
        this.closed = false;
        this.isStopped = false;
        this.hasError = false;
        this.thrownError = null;
    }
    Subject.prototype[rxSubscriber.$$rxSubscriber] = function () {
        return new SubjectSubscriber(this);
    };
    Subject.prototype.lift = function (operator) {
        var subject = new AnonymousSubject(this, this);
        subject.operator = operator;
        return subject;
    };
    Subject.prototype.next = function (value) {
        if (this.closed) {
            throw new ObjectUnsubscribedError_1.ObjectUnsubscribedError();
        }
        if (!this.isStopped) {
            var observers = this.observers;
            var len = observers.length;
            var copy = observers.slice();
            for (var i = 0; i < len; i++) {
                copy[i].next(value);
            }
        }
    };
    Subject.prototype.error = function (err) {
        if (this.closed) {
            throw new ObjectUnsubscribedError_1.ObjectUnsubscribedError();
        }
        this.hasError = true;
        this.thrownError = err;
        this.isStopped = true;
        var observers = this.observers;
        var len = observers.length;
        var copy = observers.slice();
        for (var i = 0; i < len; i++) {
            copy[i].error(err);
        }
        this.observers.length = 0;
    };
    Subject.prototype.complete = function () {
        if (this.closed) {
            throw new ObjectUnsubscribedError_1.ObjectUnsubscribedError();
        }
        this.isStopped = true;
        var observers = this.observers;
        var len = observers.length;
        var copy = observers.slice();
        for (var i = 0; i < len; i++) {
            copy[i].complete();
        }
        this.observers.length = 0;
    };
    Subject.prototype.unsubscribe = function () {
        this.isStopped = true;
        this.closed = true;
        this.observers = null;
    };
    Subject.prototype._subscribe = function (subscriber) {
        if (this.closed) {
            throw new ObjectUnsubscribedError_1.ObjectUnsubscribedError();
        }
        else if (this.hasError) {
            subscriber.error(this.thrownError);
            return Subscription_1.Subscription.EMPTY;
        }
        else if (this.isStopped) {
            subscriber.complete();
            return Subscription_1.Subscription.EMPTY;
        }
        else {
            this.observers.push(subscriber);
            return new SubjectSubscription_1.SubjectSubscription(this, subscriber);
        }
    };
    Subject.prototype.asObservable = function () {
        var observable = new Observable_1.Observable();
        observable.source = this;
        return observable;
    };
    Subject.create = function (destination, source) {
        return new AnonymousSubject(destination, source);
    };
    return Subject;
}(Observable_1.Observable));
var Subject_2 = Subject;
/**
 * @class AnonymousSubject<T>
 */
var AnonymousSubject = (function (_super) {
    __extends$5(AnonymousSubject, _super);
    function AnonymousSubject(destination, source) {
        _super.call(this);
        this.destination = destination;
        this.source = source;
    }
    AnonymousSubject.prototype.next = function (value) {
        var destination = this.destination;
        if (destination && destination.next) {
            destination.next(value);
        }
    };
    AnonymousSubject.prototype.error = function (err) {
        var destination = this.destination;
        if (destination && destination.error) {
            this.destination.error(err);
        }
    };
    AnonymousSubject.prototype.complete = function () {
        var destination = this.destination;
        if (destination && destination.complete) {
            this.destination.complete();
        }
    };
    AnonymousSubject.prototype._subscribe = function (subscriber) {
        var source = this.source;
        if (source) {
            return this.source.subscribe(subscriber);
        }
        else {
            return Subscription_1.Subscription.EMPTY;
        }
    };
    return AnonymousSubject;
}(Subject));

let JoyrideStepsContainerService = class JoyrideStepsContainerService {
    constructor() {
        this.stepHasBeenModified = new Subject_2();
        this.steps = [];
    }
    get(index) {
        return this.steps[index];
    }
    getStepPosition(step) {
        return this.getStepIndex(step) + 1;
    }
    addStep(step) {
        this.steps.push(step);
    }
    getNumberOfSteps() {
        return this.steps.length;
    }
    setPosition(step, position) {
        let index = this.getStepIndex(step);
        this.steps[index].position = position;
        this.stepHasBeenModified.next(this.steps[index]);
    }
    orderStepsByIndex() {
        this.steps = this.steps.sort((a, b) => {
            return a.stepNumber - b.stepNumber;
        });
    }
    getStepIndex(step) {
        return this.steps.indexOf(step);
    }
};
JoyrideStepsContainerService = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [])
], JoyrideStepsContainerService);

class JoyrideError extends Error {
}

const DEFAULT_THEME_COLOR = "#3b5560";
const BACKDROP_DEFAULT_COLOR = DEFAULT_THEME_COLOR;
const BUTTONS_DEFAULT_COLOR = DEFAULT_THEME_COLOR;
const STEP_DEFAULT_POSITION = "bottom";
let JoyrideOptionsService = class JoyrideOptionsService {
    constructor() {
        this.backdropColor = BACKDROP_DEFAULT_COLOR;
        this.buttonsColor = BUTTONS_DEFAULT_COLOR;
        this.stepDefaultPosition = STEP_DEFAULT_POSITION;
    }
    setOptions(options) {
        this.stepDefaultPosition = options.stepDefaultPosition ? options.stepDefaultPosition : this.stepDefaultPosition;
    }
    getBackdropColor() {
        return this.hexToRgb(this.backdropColor);
    }
    getButtonsColor() {
        return this.buttonsColor;
    }
    getStepDefaultPosition() {
        return this.stepDefaultPosition;
    }
    hexToRgb(hex) {
        var shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])$/i;
        hex = hex.replace(shorthandRegex, (m, r, g, b) => {
            return r + r + g + g + b + b;
        });
        var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
        return result ?
            `${parseInt(result[1], 16)}, ${parseInt(result[2], 16)}, ${parseInt(result[3], 16)}` : null;
    }
};
JoyrideOptionsService = __decorate([
    Injectable()
], JoyrideOptionsService);

const TARGET_ATTRIBUTE = "data-joyride-step-number";
let JoyrideDirective = class JoyrideDirective {
    constructor(el, joyrideStepsContainer, optionsService, viewContainerRef, renderer) {
        this.el = el;
        this.joyrideStepsContainer = joyrideStepsContainer;
        this.optionsService = optionsService;
        this.viewContainerRef = viewContainerRef;
        this.renderer = renderer;
        this.stepPosition = this.optionsService.getStepDefaultPosition();
    }
    ngAfterViewInit() {
        this.validateInputs();
        let step = new JoyrideStep();
        step.idSelector = this.getStepNumber();
        this.renderer.setAttribute(this.el.nativeElement, TARGET_ATTRIBUTE, this.getStepNumber());
        step.stepNumber = this.stepNumber;
        step.position = this.stepPosition;
        step.targetViewContainer = this.viewContainerRef;
        step.text = this.text;
        step.title = this.title;
        this.joyrideStepsContainer.addStep(step);
    }
    getStepNumber() {
        return this.stepNumber.toString();
    }
    validateInputs() {
        let errors = [];
        if (this.stepNumber < 0) {
            errors.push(new JoyrideError("You have added a step with stepNumber = " + this.stepNumber + ". Steps number must be positive!"));
        }
        errors.forEach((error) => {
            throw error;
        });
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number)
], JoyrideDirective.prototype, "stepNumber", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], JoyrideDirective.prototype, "title", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], JoyrideDirective.prototype, "text", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], JoyrideDirective.prototype, "stepPosition", void 0);
JoyrideDirective = __decorate([
    Directive({
        selector: '[joyrideStep]'
    }),
    __metadata("design:paramtypes", [typeof (_a = typeof ElementRef !== "undefined" && ElementRef) === "function" && _a || Object, typeof (_b = typeof JoyrideStepsContainerService !== "undefined" && JoyrideStepsContainerService) === "function" && _b || Object, typeof (_c = typeof JoyrideOptionsService !== "undefined" && JoyrideOptionsService) === "function" && _c || Object, typeof (_d = typeof ViewContainerRef !== "undefined" && ViewContainerRef) === "function" && _d || Object, typeof (_e = typeof Renderer2 !== "undefined" && Renderer2) === "function" && _e || Object])
], JoyrideDirective);
var _a, _b, _c, _d, _e;

function getWindow() {
    return window;
}
let DomRefService = class DomRefService {
    get nativeWindow() {
        return getWindow();
    }
};
DomRefService = __decorate([
    Injectable()
], DomRefService);

let DocumentService = class DocumentService {
    constructor(DOMService) {
        this.DOMService = DOMService;
    }
    getElementAbsoluteTop(elementRef) {
        var scrollOffsets = this.getScrollOffsets();
        return elementRef.nativeElement.getBoundingClientRect().top + scrollOffsets.y;
    }
    getElementAbsoluteLeft(elementRef) {
        var scrollOffsets = this.getScrollOffsets();
        return elementRef.nativeElement.getBoundingClientRect().left + scrollOffsets.x;
    }
    getElementAbsoluteRight(elementRef) {
        var scrollOffsets = this.getScrollOffsets();
        console.log("RIGHT:", elementRef.nativeElement.getBoundingClientRect().right);
        return elementRef.nativeElement.getBoundingClientRect().right;
    }
    getScrollOffsets() {
        var w = this.DOMService.nativeWindow;
        // This works for all browsers except IE versions 8 and before
        if (w.pageXOffset != null)
            return { x: w.pageXOffset, y: w.pageYOffset };
        // For IE (or any browser) in Standards mode
        var d = w.document;
        if (document.compatMode == "CSS1Compat")
            return { x: d.documentElement.scrollLeft, y: d.documentElement.scrollTop };
        // For browsers in Quirks mode
        return { x: d.body.scrollLeft, y: d.body.scrollTop };
    }
};
DocumentService = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [typeof (_a$1 = typeof DomRefService !== "undefined" && DomRefService) === "function" && _a$1 || Object])
], DocumentService);
var _a$1;

let JoyrideBackdropService = class JoyrideBackdropService {
    constructor(documentService, optionsService, rendererFactory) {
        this.documentService = documentService;
        this.optionsService = optionsService;
        this.lastXScroll = 0;
        this.lastYScroll = 0;
        this.renderer = rendererFactory.createRenderer(null, null);
    }
    start() {
    }
    show(elementRef, idSelector) {
        this.elementRef = elementRef;
        this.targetAbsoluteTop = this.documentService.getElementAbsoluteTop(elementRef.element);
        this.targetAbsoluteLeft = this.documentService.getElementAbsoluteLeft(elementRef.element);
        this.backdropContainer = this.renderer.createElement('div');
        this.renderer.addClass(this.backdropContainer, "backdrop-container");
        this.renderer.setStyle(this.backdropContainer, "position", "fixed");
        this.renderer.setStyle(this.backdropContainer, "top", "0px");
        this.renderer.setStyle(this.backdropContainer, "left", "0px");
        this.renderer.setStyle(this.backdropContainer, "width", "100%");
        this.renderer.setStyle(this.backdropContainer, "height", "100%");
        this.renderer.setStyle(this.backdropContainer, "z-index", "1000");
        this.renderer.appendChild(document.body, this.backdropContainer);
        this.backdropContent = this.renderer.createElement('div');
        this.renderer.addClass(this.backdropContent, "backdrop-content");
        this.renderer.setStyle(this.backdropContent, "position", "relative");
        this.renderer.setStyle(this.backdropContent, "height", "100%");
        this.renderer.setStyle(this.backdropContent, "display", "flex");
        this.renderer.setStyle(this.backdropContent, "flex-direction", "column");
        this.renderer.appendChild(this.backdropContainer, this.backdropContent);
        this.backdropTop = this.renderer.createElement('div');
        this.renderer.addClass(this.backdropTop, "joyride-backdrop");
        this.renderer.addClass(this.backdropTop, "backdrop-top");
        this.renderer.setStyle(this.backdropTop, "width", "100%");
        this.renderer.setStyle(this.backdropTop, "height", this.targetAbsoluteTop - this.lastYScroll + 'px');
        this.renderer.setStyle(this.backdropTop, "flex-shrink", "0");
        this.renderer.setStyle(this.backdropTop, "background-color", `rgba(${this.optionsService.getBackdropColor()}, 0.7)`);
        this.renderer.appendChild(this.backdropContent, this.backdropTop);
        this.backdropMiddleContainer = this.renderer.createElement('div');
        this.renderer.addClass(this.backdropMiddleContainer, "backdrop-middle-container");
        this.renderer.setStyle(this.backdropMiddleContainer, "height", elementRef.element.nativeElement.offsetHeight + 'px');
        this.renderer.setStyle(this.backdropMiddleContainer, "width", "100%");
        this.renderer.setStyle(this.backdropMiddleContainer, "flex-shrink", "0");
        this.renderer.appendChild(this.backdropContent, this.backdropMiddleContainer);
        this.backdropMiddleContent = this.renderer.createElement('div');
        this.renderer.addClass(this.backdropMiddleContent, "backdrop-middle-content");
        this.renderer.setStyle(this.backdropMiddleContent, "display", "flex");
        this.renderer.setStyle(this.backdropMiddleContent, "width", "100%");
        this.renderer.setStyle(this.backdropMiddleContent, "height", "100%");
        this.renderer.appendChild(this.backdropMiddleContainer, this.backdropMiddleContent);
        this.leftBackdrop = this.renderer.createElement('div');
        this.renderer.addClass(this.leftBackdrop, "joyride-backdrop");
        this.renderer.addClass(this.leftBackdrop, "backdrop-left");
        this.renderer.setStyle(this.leftBackdrop, "flex-shrink", "0");
        this.renderer.setStyle(this.leftBackdrop, "width", this.targetAbsoluteLeft - this.lastXScroll + "px");
        this.renderer.setStyle(this.leftBackdrop, "background-color", `rgba(${this.optionsService.getBackdropColor()}, 0.7)`);
        this.renderer.appendChild(this.backdropMiddleContent, this.leftBackdrop);
        this.targetBackdrop = this.renderer.createElement('div');
        this.renderer.addClass(this.targetBackdrop, "backdrop-target");
        this.renderer.setStyle(this.targetBackdrop, "flex-shrink", "0");
        this.renderer.setStyle(this.targetBackdrop, "width", elementRef.element.nativeElement.offsetWidth + 'px');
        this.renderer.appendChild(this.backdropMiddleContent, this.targetBackdrop);
        this.rightBackdrop = this.renderer.createElement('div');
        this.renderer.addClass(this.rightBackdrop, "joyride-backdrop");
        this.renderer.addClass(this.rightBackdrop, "backdrop-right");
        this.renderer.setStyle(this.rightBackdrop, "width", "100%");
        this.renderer.setStyle(this.rightBackdrop, "background-color", `rgba(${this.optionsService.getBackdropColor()}, 0.7)`);
        this.renderer.appendChild(this.backdropMiddleContent, this.rightBackdrop);
        this.backdropBottom = this.renderer.createElement('div');
        this.renderer.addClass(this.backdropBottom, "joyride-backdrop");
        this.renderer.addClass(this.backdropBottom, "backdrop-bottom");
        this.renderer.setStyle(this.backdropBottom, "width", "100%");
        this.renderer.setStyle(this.backdropBottom, "height", "100%");
        this.renderer.setStyle(this.backdropBottom, "background-color", `rgba(${this.optionsService.getBackdropColor()}, 0.7)`);
        this.renderer.appendChild(this.backdropContent, this.backdropBottom);
    }
    hide() {
        this.removeBackdrop();
        this.elementRef = undefined;
    }
    redrawTarget(targetViewContainer) {
        this.targetAbsoluteLeft = this.documentService.getElementAbsoluteLeft(targetViewContainer.element);
        this.targetAbsoluteTop = this.documentService.getElementAbsoluteTop(targetViewContainer.element);
        this.handleVerticalScroll();
        this.handleHorizontalScroll();
    }
    redraw(scroll) {
        if (this.lastYScroll !== scroll.scrollY) {
            this.lastYScroll = scroll.scrollY;
            if (this.elementRef) {
                this.handleVerticalScroll();
            }
        }
        if (this.lastXScroll !== scroll.scrollX) {
            this.lastXScroll = scroll.scrollX;
            if (this.elementRef) {
                this.handleHorizontalScroll();
            }
        }
    }
    handleHorizontalScroll() {
        let newBackdropLeftWidth = this.targetAbsoluteLeft - this.lastXScroll;
        if (newBackdropLeftWidth >= 0) {
            this.renderer.setStyle(this.leftBackdrop, "width", newBackdropLeftWidth + 'px');
            this.renderer.setStyle(this.targetBackdrop, "width", this.elementRef.element.nativeElement.offsetWidth + 'px');
        }
        else {
            this.handleTargetPartialWidth(newBackdropLeftWidth);
        }
    }
    handleTargetPartialWidth(newBackdropLeftWidth) {
        this.renderer.setStyle(this.leftBackdrop, "width", 0 + 'px');
        let visibleTargetWidth = this.elementRef.element.nativeElement.offsetWidth + newBackdropLeftWidth;
        if (visibleTargetWidth >= 0) {
            this.renderer.setStyle(this.targetBackdrop, "width", visibleTargetWidth + 'px');
        }
        else {
            this.renderer.setStyle(this.targetBackdrop, "width", 0 + 'px');
        }
    }
    handleVerticalScroll() {
        let newBackdropTopHeight = this.targetAbsoluteTop - this.lastYScroll;
        if (newBackdropTopHeight >= 0) {
            this.renderer.setStyle(this.backdropTop, "height", newBackdropTopHeight + 'px');
            this.renderer.setStyle(this.backdropMiddleContainer, "height", this.elementRef.element.nativeElement.offsetHeight + 'px');
        }
        else {
            this.handleTargetPartialHeight(newBackdropTopHeight);
        }
    }
    handleTargetPartialHeight(newBackdropTopHeight) {
        this.renderer.setStyle(this.backdropTop, "height", 0 + 'px');
        let visibleTargetHeight = this.elementRef.element.nativeElement.offsetHeight + newBackdropTopHeight;
        if (visibleTargetHeight >= 0) {
            this.renderer.setStyle(this.backdropMiddleContainer, "height", visibleTargetHeight + 'px');
        }
        else {
            this.renderer.setStyle(this.backdropMiddleContainer, "height", 0 + 'px');
        }
    }
    removeBackdrop() {
        this.renderer.removeChild(document.body, this.backdropContainer);
    }
};
JoyrideBackdropService = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [typeof (_a$2 = typeof DocumentService !== "undefined" && DocumentService) === "function" && _a$2 || Object, typeof (_b$1 = typeof JoyrideOptionsService !== "undefined" && JoyrideOptionsService) === "function" && _b$1 || Object, typeof (_c$1 = typeof RendererFactory2 !== "undefined" && RendererFactory2) === "function" && _c$1 || Object])
], JoyrideBackdropService);
var _a$2, _b$1, _c$1;

class Scroll {
}
let EventListenerService = class EventListenerService {
    constructor(rendererFactory, DOMService) {
        this.rendererFactory = rendererFactory;
        this.DOMService = DOMService;
        this.scrollEvent = new Subject_2();
        this.resizeEvent = new Subject_2();
        this.renderer = rendererFactory.createRenderer(null, null);
    }
    startListeningScrollEvents() {
        this.scrollUnlisten = this.renderer.listen('document', 'scroll', (evt) => {
            this.scrollEvent.next({ scrollX: this.DOMService.nativeWindow.pageXOffset, scrollY: this.DOMService.nativeWindow.pageYOffset });
        });
    }
    startListeningResizeEvents() {
        this.resizeUnlisten = this.renderer.listen('window', 'resize', (evt) => {
            this.resizeEvent.next(null);
        });
    }
    stopListeningScrollEvents() {
        this.scrollUnlisten();
    }
    stopListeningResizeEvents() {
        this.resizeUnlisten();
    }
};
EventListenerService = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [typeof (_a$3 = typeof RendererFactory2 !== "undefined" && RendererFactory2) === "function" && _a$3 || Object, typeof (_b$2 = typeof DomRefService !== "undefined" && DomRefService) === "function" && _b$2 || Object])
], EventListenerService);
var _a$3, _b$2;

const STEP_MIN_WIDTH = 200;
const STEP_MAX_WIDTH = 400;
const STEP_HEIGHT = 200;
const ASPECT_RATIO = 1.212;
const DEFAULT_DISTANCE_FROM_MARGIN_LEFT = 2;
const DEFAULT_DISTANCE_FROM_MARGIN_RIGHT = 5;
const closeSvg = require('../assets/images/close.svg');
let JoyrideStepComponent = class JoyrideStepComponent {
    constructor(injector, stepsContainerService, eventListenerService, documentService, viewContainerRef, renderer) {
        this.stepsContainerService = stepsContainerService;
        this.eventListenerService = eventListenerService;
        this.documentService = documentService;
        this.viewContainerRef = viewContainerRef;
        this.renderer = renderer;
        this.stepWidth = STEP_MIN_WIDTH;
        this.stepHeight = STEP_HEIGHT;
        this.closeSvg = closeSvg;
        this.arrowSize = ARROW_SIZE;
        this.subscriptions = [];
        this.joyrideStepService = injector.get(JoyrideStepService);
    }
    ngOnInit() {
        this.subscriptions.push(this.subscribeToResizeEvents());
        this.title = this.step.title;
        this.text = this.step.text;
        this.counter = this.getCounter();
    }
    ngAfterViewInit() {
        let dimensions = this.getDimensionsByAspectRatio(this.stepContainer.nativeElement.clientWidth, this.stepContainer.nativeElement.clientHeight, ASPECT_RATIO);
        dimensions = this.adjustDimensions(dimensions.width, dimensions.height);
        this.stepWidth = dimensions.width;
        this.stepHeight = dimensions.height;
        this.renderer.setStyle(this.stepContainer.nativeElement, "width", this.stepWidth + 'px');
        this.renderer.setStyle(this.stepContainer.nativeElement, "height", this.stepHeight + 'px');
        this.drawStep();
    }
    drawStep() {
        this.targetWidth = this.step.targetViewContainer.element.nativeElement.getBoundingClientRect().width;
        this.targetHeight = this.step.targetViewContainer.element.nativeElement.getBoundingClientRect().height;
        this.targetOffsetTop = this.step.targetViewContainer.element.nativeElement.offsetTop;
        this.targetOffsetLeft = this.step.targetViewContainer.element.nativeElement.offsetLeft;
        this.targetAbsoluteLeft = this.documentService.getElementAbsoluteLeft(this.step.targetViewContainer.element);
        this.targetAbsoluteTop = this.documentService.getElementAbsoluteTop(this.step.targetViewContainer.element);
        this.setStepStyle();
    }
    getCounter() {
        let stepPosition = this.stepsContainerService.getStepPosition(this.step);
        let numberOfStep = this.stepsContainerService.getNumberOfSteps();
        return stepPosition + '/' + numberOfStep;
    }
    prev() {
        this.joyrideStepService.prev();
    }
    next() {
        this.joyrideStepService.next();
    }
    close() {
        this.joyrideStepService.close();
    }
    isFirstStep() {
        return this.joyrideStepService.isFirstStep();
    }
    isLastStep() {
        return this.joyrideStepService.isLastStep();
    }
    setStepStyle() {
        switch (this.step.position) {
            case 'top': {
                this.setStyleTop();
                break;
            }
            case 'bottom': {
                this.setStyleBottom();
                break;
            }
            default: {
                this.setStyleBottom();
            }
        }
    }
    setStyleBottom() {
        this.topPosition = this.targetOffsetTop + this.targetHeight + DISTANCE_FROM_TARGET;
        this.arrowTopPosition = -this.arrowSize;
        this.arrowLeftPosition = this.stepWidth / 2 - this.arrowSize;
        this.leftPosition = this.targetWidth / 2 - this.stepWidth / 2 + this.targetOffsetLeft;
        this.stepAbsoluteLeft = this.targetWidth / 2 - this.stepWidth / 2 + this.targetAbsoluteLeft;
        this.adjustLeftPosition();
        this.adjustRightPosition();
        this.arrowPosition = 'top';
        this.adjustBottomPosition();
    }
    setStyleTop() {
        this.topPosition = this.targetOffsetTop - DISTANCE_FROM_TARGET - this.stepHeight;
        this.arrowTopPosition = this.stepHeight;
        this.leftPosition = this.targetWidth / 2 - this.stepWidth / 2 + this.targetOffsetLeft;
        this.stepAbsoluteLeft = this.targetWidth / 2 - this.stepWidth / 2 + this.targetAbsoluteLeft;
        this.arrowLeftPosition = this.stepWidth / 2 - this.arrowSize;
        this.adjustLeftPosition();
        this.adjustRightPosition();
        this.arrowPosition = 'bottom';
        this.adjustTopPosition();
    }
    adjustLeftPosition() {
        if (this.leftPosition < 0) {
            this.arrowLeftPosition = this.arrowLeftPosition + this.leftPosition - DEFAULT_DISTANCE_FROM_MARGIN_LEFT;
            this.leftPosition = DEFAULT_DISTANCE_FROM_MARGIN_LEFT;
        }
    }
    adjustRightPosition() {
        let currentWindowWidth = document.body.clientWidth;
        if (this.stepAbsoluteLeft + this.stepWidth > currentWindowWidth) {
            let newLeftPos = this.leftPosition - (this.stepAbsoluteLeft + this.stepWidth + DEFAULT_DISTANCE_FROM_MARGIN_RIGHT - currentWindowWidth);
            let deltaLeftPosition = newLeftPos - this.leftPosition;
            this.leftPosition = newLeftPos;
            this.arrowLeftPosition = this.arrowLeftPosition - deltaLeftPosition;
        }
    }
    adjustBottomPosition() {
        if (this.targetAbsoluteTop + this.stepHeight + this.arrowSize - this.targetHeight > document.body.clientHeight) {
            this.setStyleTop();
            this.stepsContainerService.setPosition(this.step, 'top');
        }
    }
    adjustTopPosition() {
        if (this.targetAbsoluteTop - this.stepHeight - this.arrowSize < 0) {
            this.setStyleBottom();
            this.stepsContainerService.setPosition(this.step, 'bottom');
        }
    }
    subscribeToResizeEvents() {
        return this.eventListenerService.resizeEvent.subscribe(() => {
            this.drawStep();
        });
    }
    getDimensionsByAspectRatio(width, height, aspectRatio) {
        let calcHeight = (width + height) / (1 + aspectRatio);
        let calcWidth = calcHeight * aspectRatio;
        return {
            width: calcWidth,
            height: calcHeight
        };
    }
    adjustDimensions(width, height) {
        let area = width * height;
        let newWidth = width;
        let newHeight = height;
        if (width > STEP_MAX_WIDTH) {
            newWidth = STEP_MAX_WIDTH;
            newHeight = area / newWidth;
        }
        else if (width < STEP_MIN_WIDTH) {
            newWidth = STEP_MIN_WIDTH;
            newHeight = STEP_MIN_WIDTH / ASPECT_RATIO;
        }
        return {
            width: newWidth,
            height: newHeight
        };
    }
    ngOnDestroy() {
        this.subscriptions.forEach((subscription) => {
            subscription.unsubscribe();
        });
    }
};
__decorate([
    Input(),
    __metadata("design:type", typeof (_a$4 = typeof JoyrideStep !== "undefined" && JoyrideStep) === "function" && _a$4 || Object)
], JoyrideStepComponent.prototype, "step", void 0);
__decorate([
    ViewChild('stepContainer'),
    __metadata("design:type", typeof (_b$3 = typeof ElementRef !== "undefined" && ElementRef) === "function" && _b$3 || Object)
], JoyrideStepComponent.prototype, "stepContainer", void 0);
JoyrideStepComponent = __decorate([
    Component({
        selector: 'joyride-step',
        template: `<div class="joyride-step__holder" [style.top.px]="topPosition" [style.left.px]="leftPosition">
    <joyride-arrow class="joyride-step__arrow" [position]="arrowPosition" [style.top.px]="arrowTopPosition" [style.left.px]="arrowLeftPosition"></joyride-arrow>
    <div #stepContainer class="joyride-step__container">
        <img  [src]="closeSvg" class="joyride-step__close" (click)="close()">
        <div class="joyride-step__header">
            <div class="joyride-step__title">{{title}}</div>
        </div>
        <div class="joyride-step__body">{{text}}</div>
        <div class="joyride-step__footer">
            <div class="joyride-step__counter">{{counter}}</div>
            <div class="joyride-step__buttons-container">
                <button class="joyride-step__button" *ngIf="!isFirstStep()" (click)="prev()">Prev</button>
                <button class="joyride-step__button" *ngIf="!isLastStep(); else doneButton" (click)="next()">Next</button>
                <ng-template #doneButton>
                    <button class="joyride-step__button" (click)="close()">Done</button>
                </ng-template>
            </div>
        </div>
    </div>
</div>`,
        styles: [`.joyride-step__holder {
  position: absolute;
  z-index: 1001; }

.joyride-step__arrow {
  position: absolute;
  left: 40px;
  z-index: 1002; }

.joyride-step__container {
  box-sizing: border-box;
  position: relative;
  color: #000000;
  background-color: #FFFFFF;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  padding: 10px;
  box-shadow: 0px 0px 30px 1px #000000;
  max-width: 400px; }

.joyride-step__header {
  display: flex;
  align-items: center;
  padding: 4px 15px; }

.joyride-step__title {
  font-weight: bold;
  text-transform: uppercase; }

.joyride-step__close {
  position: absolute;
  right: 10px;
  top: 10px;
  width: 14px;
  cursor: pointer; }

.joyride-step__body {
  text-align: left;
  padding: 10px 15px; }

.joyride-step__footer {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  align-items: center; }

.joyride-step__counter {
  font-weight: bold;
  font-size: 14px; }

.joyride-step__button {
  text-transform: uppercase;
  border: 2px solid transparent;
  outline: none;
  padding: 6px 12px;
  font-size: 12px;
  font-weight: bold;
  color: white;
  background-color: #3b5560;
  cursor: pointer; }
  .joyride-step__button:hover {
    color: #3b5560;
    border: 2px solid #3b5560;
    background-color: white; }
`],
        encapsulation: ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [typeof (_c$2 = typeof Injector !== "undefined" && Injector) === "function" && _c$2 || Object, typeof (_d$1 = typeof JoyrideStepsContainerService !== "undefined" && JoyrideStepsContainerService) === "function" && _d$1 || Object, typeof (_e$1 = typeof EventListenerService !== "undefined" && EventListenerService) === "function" && _e$1 || Object, typeof (_f = typeof DocumentService !== "undefined" && DocumentService) === "function" && _f || Object, typeof (_g = typeof ViewContainerRef !== "undefined" && ViewContainerRef) === "function" && _g || Object, typeof (_h = typeof Renderer2 !== "undefined" && Renderer2) === "function" && _h || Object])
], JoyrideStepComponent);
var _a$4, _b$3, _c$2, _d$1, _e$1, _f, _g, _h;

let StepDrawerService = class StepDrawerService {
    constructor(componentFactoryResolver) {
        this.componentFactoryResolver = componentFactoryResolver;
    }
    draw(step) {
        const factory = this.componentFactoryResolver.resolveComponentFactory(JoyrideStepComponent);
        const ref = step.targetViewContainer.createComponent(factory);
        const instance = ref.instance;
        instance.step = step;
        ref.changeDetectorRef.detectChanges();
        step.stepInstance = instance;
    }
};
StepDrawerService = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [typeof (_a$5 = typeof ComponentFactoryResolver !== "undefined" && ComponentFactoryResolver) === "function" && _a$5 || Object])
], StepDrawerService);
var _a$5;

const SCROLLBAR_SIZE = 20;
const DISTANCE_FROM_TARGET = 15;
const ARROW_SIZE = 10;
let JoyrideStepService = class JoyrideStepService {
    constructor(componentFactoryResolver, backDropService, eventListener, stepsContainerService, documentService, DOMService, stepDrawerService) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.backDropService = backDropService;
        this.eventListener = eventListener;
        this.stepsContainerService = stepsContainerService;
        this.documentService = documentService;
        this.DOMService = DOMService;
        this.stepDrawerService = stepDrawerService;
        this.winTopPosition = 0;
        this.winBottomPosition = 0;
        this.initViewportPositions();
        this.subscribeToScrollEvents();
        this.subscribeToResizeEvents();
    }
    initViewportPositions() {
        this.winTopPosition = 0;
        this.winBottomPosition = this.DOMService.nativeWindow.innerHeight - SCROLLBAR_SIZE;
    }
    subscribeToScrollEvents() {
        this.eventListener.startListeningScrollEvents();
        this.eventListener.scrollEvent.subscribe((scroll) => {
            this.winTopPosition = scroll.scrollY;
            this.winBottomPosition = this.winTopPosition + this.DOMService.nativeWindow.innerHeight - SCROLLBAR_SIZE;
            this.backDropService.redraw(scroll);
        });
    }
    subscribeToResizeEvents() {
        this.eventListener.resizeEvent.subscribe(() => {
            this.backDropService.redrawTarget(this.currentStep.targetViewContainer);
        });
    }
    drawStep(step) {
        this.stepDrawerService.draw(step);
    }
    startTour() {
        this.stepsContainerService.orderStepsByIndex();
        console.debug("Starting tour...");
        this.backDropService.start();
        this.currentStepIndex = 0;
        this.currentStep = this.stepsContainerService.get(this.currentStepIndex);
        this.showCurrentStep();
        this.eventListener.startListeningResizeEvents();
        this.subscribeToStepsUpdates();
    }
    close() {
        this.removeCurrentStep();
        this.DOMService.nativeWindow.scrollTo(0, 0);
        this.eventListener.stopListeningResizeEvents();
    }
    prev() {
        console.debug("clicked prev");
        this.removeCurrentStep();
        this.currentStepIndex -= 1;
        this.currentStep = this.stepsContainerService.get(this.currentStepIndex);
        this.showCurrentStep();
    }
    next() {
        console.debug("clicked next");
        this.removeCurrentStep();
        this.currentStepIndex += 1;
        this.currentStep = this.stepsContainerService.get(this.currentStepIndex);
        this.showCurrentStep();
    }
    isFirstStep() {
        return this.currentStepIndex === 0;
    }
    isLastStep() {
        return this.currentStepIndex === this.stepsContainerService.getNumberOfSteps() - 1;
    }
    subscribeToStepsUpdates() {
        this.stepsContainerService.stepHasBeenModified.subscribe((updatedStep) => {
            if (this.currentStep.stepNumber === updatedStep.stepNumber) {
                this.currentStep = updatedStep;
            }
        });
    }
    showCurrentStep() {
        //this.backDropService.show(this.currentStep.idSelector);
        this.backDropService.show(this.currentStep.targetViewContainer, this.currentStep.idSelector);
        this.drawStep(this.currentStep);
        this.scrollIfTargetNotVisible();
    }
    removeCurrentStep() {
        this.backDropService.hide();
        this.detachStep(this.currentStep);
    }
    detachStep(step) {
        step.targetViewContainer.remove(step.stepNumber);
    }
    scrollIfTargetNotVisible() {
        this.scrollWhenTargetIsHiddenBottom();
        this.scrollWhenTargetIsHiddenTop();
    }
    scrollWhenTargetIsHiddenBottom() {
        let totalTargetBottom = this.getTotalTargetBottomPosition();
        if (totalTargetBottom > this.winBottomPosition) {
            this.DOMService.nativeWindow.scrollBy(0, totalTargetBottom - this.winBottomPosition);
        }
    }
    scrollWhenTargetIsHiddenTop() {
        let totalTargetTop = this.getTotalTargetTopPosition();
        if (totalTargetTop < this.winTopPosition) {
            this.DOMService.nativeWindow.scrollBy(0, totalTargetTop - this.winTopPosition);
        }
    }
    getTotalTargetBottomPosition() {
        let targetAbsoluteTop = this.documentService.getElementAbsoluteTop(this.currentStep.targetViewContainer.element);
        if (this.currentStep.position === 'top') {
            return targetAbsoluteTop + this.currentStep.stepInstance.targetHeight;
        }
        else if (this.currentStep.position === 'bottom') {
            return targetAbsoluteTop + this.currentStep.stepInstance.targetHeight + this.currentStep.stepInstance.stepHeight + ARROW_SIZE + DISTANCE_FROM_TARGET;
        }
    }
    getTotalTargetTopPosition() {
        let targetAbsoluteTop = this.documentService.getElementAbsoluteTop(this.currentStep.targetViewContainer.element);
        if (this.currentStep.position === 'top') {
            return targetAbsoluteTop - (this.currentStep.stepInstance.stepHeight + ARROW_SIZE + DISTANCE_FROM_TARGET);
        }
        else if (this.currentStep.position === 'bottom') {
            return targetAbsoluteTop;
        }
    }
};
JoyrideStepService = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [typeof (_a$6 = typeof ComponentFactoryResolver !== "undefined" && ComponentFactoryResolver) === "function" && _a$6 || Object, typeof (_b$4 = typeof JoyrideBackdropService !== "undefined" && JoyrideBackdropService) === "function" && _b$4 || Object, typeof (_c$3 = typeof EventListenerService !== "undefined" && EventListenerService) === "function" && _c$3 || Object, typeof (_d$2 = typeof JoyrideStepsContainerService !== "undefined" && JoyrideStepsContainerService) === "function" && _d$2 || Object, typeof (_e$2 = typeof DocumentService !== "undefined" && DocumentService) === "function" && _e$2 || Object, typeof (_f$1 = typeof DomRefService !== "undefined" && DomRefService) === "function" && _f$1 || Object, typeof (_g$1 = typeof StepDrawerService !== "undefined" && StepDrawerService) === "function" && _g$1 || Object])
], JoyrideStepService);
var _a$6, _b$4, _c$3, _d$2, _e$2, _f$1, _g$1;

let JoyrideService = class JoyrideService {
    constructor(stepService, optionsService) {
        this.stepService = stepService;
        this.optionsService = optionsService;
    }
    setOptions(options) {
        this.optionsService.setOptions(options);
    }
    startTour() {
        this.stepService.startTour();
    }
};
JoyrideService = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [typeof (_a$7 = typeof JoyrideStepService !== "undefined" && JoyrideStepService) === "function" && _a$7 || Object, typeof (_b$5 = typeof JoyrideOptionsService !== "undefined" && JoyrideOptionsService) === "function" && _b$5 || Object])
], JoyrideService);
var _a$7, _b$5;

let JoyrideArrowComponent = class JoyrideArrowComponent {
    constructor() {
        this.position = 'top';
    }
};
__decorate([
    Input(),
    __metadata("design:type", String)
], JoyrideArrowComponent.prototype, "position", void 0);
JoyrideArrowComponent = __decorate([
    Component({
        selector: 'joyride-arrow',
        template: `<div [class.joyride-arrow__top]="position == 'top'"
     [class.joyride-arrow__bottom]="position == 'bottom'"
     [class.joyride-arrow__left]="position == 'left'"
     [class.joyride-arrow__right]="position == 'right'">
</div>`,
        styles: [`.joyride-arrow__top {
  border-left: 11px solid transparent;
  border-right: 11px solid transparent;
  border-bottom: 11px solid #ffffff; }

.joyride-arrow__bottom {
  border-left: 11px solid transparent;
  border-right: 11px solid transparent;
  border-top: 11px solid #ffffff; }
`],
        encapsulation: ViewEncapsulation.None
    })
], JoyrideArrowComponent);

let JoyrideModule = class JoyrideModule {
};
JoyrideModule = __decorate([
    NgModule({
        imports: [CommonModule],
        declarations: [
            JoyrideDirective,
            JoyrideStepComponent,
            JoyrideArrowComponent
        ],
        entryComponents: [JoyrideStepComponent],
        exports: [
            JoyrideDirective
        ],
        providers: [
            JoyrideService,
            JoyrideStepService,
            JoyrideStepsContainerService,
            JoyrideBackdropService,
            EventListenerService,
            DocumentService,
            JoyrideOptionsService,
            StepDrawerService,
            DomRefService
        ],
    })
], JoyrideModule);

export { JoyrideStepComponent, JoyrideArrowComponent, JoyrideModule, JoyrideService, TARGET_ATTRIBUTE, JoyrideDirective, DISTANCE_FROM_TARGET, ARROW_SIZE, JoyrideStepService, JoyrideBackdropService, Scroll, EventListenerService, JoyrideStepsContainerService, DocumentService, JoyrideOptionsService, StepDrawerService, DomRefService };
//# sourceMappingURL=angular2-joyride.esm2015.js.map
