import { AfterViewInit, OnInit, OnDestroy, ViewContainerRef, ElementRef, Renderer2, Injector } from "@angular/core";
import { JoyrideStep } from "../models/joyride-step.class";
import { JoyrideStepsContainerService } from "../services/joyride-steps-container.service";
import { EventListenerService } from "../services/event-listener.service";
import { DocumentService } from "../services/document.service";
export declare class JoyrideStepComponent implements OnInit, OnDestroy, AfterViewInit {
    private readonly stepsContainerService;
    private readonly eventListenerService;
    private readonly documentService;
    private readonly viewContainerRef;
    private readonly renderer;
    stepWidth: number;
    stepHeight: number;
    leftPosition: number;
    topPosition: number;
    arrowPosition: string;
    arrowLeftPosition: number;
    arrowTopPosition: number;
    closeSvg: any;
    title: string;
    text: string;
    counter: string;
    private arrowSize;
    private stepAbsoluteLeft;
    private targetWidth;
    targetHeight: number;
    private targetOffsetTop;
    private targetOffsetLeft;
    private targetAbsoluteLeft;
    private targetAbsoluteTop;
    private subscriptions;
    private joyrideStepService;
    step?: JoyrideStep;
    stepContainer: ElementRef;
    constructor(injector: Injector, stepsContainerService: JoyrideStepsContainerService, eventListenerService: EventListenerService, documentService: DocumentService, viewContainerRef: ViewContainerRef, renderer: Renderer2);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    private drawStep();
    private getCounter();
    prev(): void;
    next(): void;
    close(): void;
    isFirstStep(): boolean;
    isLastStep(): boolean;
    private setStepStyle();
    private setStyleBottom();
    private setStyleTop();
    private adjustLeftPosition();
    private adjustRightPosition();
    private adjustBottomPosition();
    private adjustTopPosition();
    private subscribeToResizeEvents();
    private getDimensionsByAspectRatio(width, height, aspectRatio);
    private adjustDimensions(width, height);
    ngOnDestroy(): void;
}
