import { RendererFactory2, ViewContainerRef } from "@angular/core";
import { DocumentService } from "./document.service";
import { Scroll } from "./event-listener.service";
import { JoyrideOptionsService } from "./joyride-options.service";
export declare class JoyrideBackdropService {
    private readonly documentService;
    private readonly optionsService;
    private renderer;
    private backdropContainer;
    private backdropContent;
    private backdropTop;
    private backdropBottom;
    private backdropMiddleContainer;
    private backdropMiddleContent;
    private leftBackdrop;
    private targetBackdrop;
    private rightBackdrop;
    private elementRef;
    private targetAbsoluteTop;
    private targetAbsoluteLeft;
    private lastXScroll;
    private lastYScroll;
    constructor(documentService: DocumentService, optionsService: JoyrideOptionsService, rendererFactory: RendererFactory2);
    start(): void;
    show(elementRef: ViewContainerRef, idSelector: string): void;
    hide(): void;
    redrawTarget(targetViewContainer: ViewContainerRef): void;
    redraw(scroll: Scroll): void;
    private handleHorizontalScroll();
    private handleTargetPartialWidth(newBackdropLeftWidth);
    private handleVerticalScroll();
    private handleTargetPartialHeight(newBackdropTopHeight);
    private removeBackdrop();
}
