import { ComponentFactoryResolver } from "@angular/core";
import { JoyrideBackdropService } from "../services/joyride-backdrop.service";
import { EventListenerService } from "../services/event-listener.service";
import { JoyrideStepsContainerService } from "../services/joyride-steps-container.service";
import { DocumentService } from "../services/document.service";
import { StepDrawerService } from "./step-drawer.service";
import { DomRefService } from "./dom.service";
export declare const DISTANCE_FROM_TARGET = 15;
export declare const ARROW_SIZE = 10;
export declare class JoyrideStepService {
    private readonly componentFactoryResolver;
    private readonly backDropService;
    private readonly eventListener;
    private readonly stepsContainerService;
    private readonly documentService;
    private readonly DOMService;
    private readonly stepDrawerService;
    private currentStepIndex;
    private currentStep;
    private winTopPosition;
    private winBottomPosition;
    constructor(componentFactoryResolver: ComponentFactoryResolver, backDropService: JoyrideBackdropService, eventListener: EventListenerService, stepsContainerService: JoyrideStepsContainerService, documentService: DocumentService, DOMService: DomRefService, stepDrawerService: StepDrawerService);
    private initViewportPositions();
    private subscribeToScrollEvents();
    private subscribeToResizeEvents();
    private drawStep(step);
    startTour(): void;
    close(): void;
    prev(): void;
    next(): void;
    isFirstStep(): boolean;
    isLastStep(): boolean;
    private subscribeToStepsUpdates();
    private showCurrentStep();
    private removeCurrentStep();
    private detachStep(step);
    private scrollIfTargetNotVisible();
    private scrollWhenTargetIsHiddenBottom();
    private scrollWhenTargetIsHiddenTop();
    private getTotalTargetBottomPosition();
    private getTotalTargetTopPosition();
}
